#include "iot.h"
#include "sys.h"
#include "uart.h"
#include <string.h>

char ATIMEI[] = "123456789013245", ATIMEIMark = 0;
char ATICCID[] = "12345678901324567890", ATICCIDMark = 0;
char ATCSQ[] = "00", ATCSQMark = 0;
char tcpConnectStatus = 0;																										// TCP״̬0δӣ1

const char ATStrDoiot[] = "doiot";
const char ATStrATplus[] = "+++";
const char ATStrATplusOK[] = "+++";
const char ATStrAT[] = "AT\r\n";			
const char ATStrATOK[] = "AT\r\n\r\nOK";																							// ATͨ
const char ATStrIMEI[] = "AT+IMEI\r\n";																				// ȡIMEI
const char ATStrCCID[] = "AT+CCID\r\n";																				// ȡICCID
const char ATStrCreg[] = "AT+CREG?\r\n";																			// ȡź״̬
const char ATStrCSQ[] = "AT+CSQ\r\n";																					// ȡźǿ
const char ATStrCGDCONT[] = "AT+CGDCONT=1,\"IP\",\"CMIOTQPCAR.JS\"\r\n";			// APN CMIOTQPCAR.JS
const char ATStrCGDCONTOK[] = "AT+CGDCONT=1,\"IP\",\"CMIOTQPCAR.JS\"\r\n\r\nOK";			// APN CMIOTQPCAR.JS
const char ATStrCGACT[] = "AT+CGACT=1,1\r\n";																	// PDP
const char ATStrCGACT0[] = "AT+CGACT=0\r\n";																	// ȥPDP
const char ATStrMIPMODE[] = "AT+MIPMODE=0,1\r\n";															// Ϊ͸ģʽ
const char ATStrMIPOPEN[] = "AT+MIPOPEN=0,\"TCP\",\"47.108.129.27\",12345\r\n";// TCP
const char ATStrMIPOPENOK[] = "AT+MIPOPEN=0,\"TCP\",\"47.108.129.27\",12345\r\n\r\nOK\r\n\r\nCONNECT OK";				// TCPɹ
const char ATStrMIPOPENERROR[] = "AT+MIPOPEN=0,\"TCP\",\"47.108.129.27\",12345\r\n\r\nOK\r\n\r\nERROR";					// TCPʧ
const char ATStrConnectOK[] = "CONNECT OK";																		// ӳɹ
const char ATStrMIPCLOSE[] = "AT+MIPCLOSE=0\r\n";															// Ͽ	
const char ATStrMIPCLOSEOK[] = "AT+MIPCLOSE=0\r\n\r\n0,CLOSE OK";							// Ͽ							
	
void IOT_Init(void)																														// ģʼ
{
	uint8_t initStep = 0, i;																										// ʼ
	uint8_t sendReturn = 0;																											// ķֵ02ʧܣ1ɹ
	uint16_t errorTime = 0;
	
	while(1)
	{
		HAL_IWDG_Refresh(&hiwdg);																									// Źι
		
		if(sysLog)
		{
			exUART_SendCharStr("ML302ģʼ:");														
			exUART_SendData(initStep);								
			exUART_SendCharStr("\r\n");						
		}		
		
		switch(initStep)
		{
			case 0:																																	// ATģʽ
				tcpConnectStatus = 0;																								  // ״̬
				exUART_SendCharStr("  ڽATģʽ...\r\n");					
				sendReturn = IOT_intoATMethod();																			// 1˵ATģʽ				
				if(sendReturn != 1)																										// δʶAT˵ûп
				{
					exUART_SendCharStr("  ATͨѶʧ, ģ鿪...\r\n");					
					sendReturn = IOT_PWR(1);																						// ɹ1ʧܷ0
				}
				else
				{
					exUART_SendCharStr("  ATͨѶɹ\r\n");					
				}
				break;
			case 1:				
				exUART_SendCharStr("  ڲѯģIMEI...\r\n");									
				sendReturn = IOT_sendAT(ATStrIMEI, 5000);															// ѯIMEI
				if(sendReturn == 1)
				{
					exUART_SendCharStr("  ģIMEI:");				
					exUART_SendCharStr(ATIMEI);
					exUART_SendCharStr("\r\n");	
				}
				else
				{
					exUART_SendCharStr("  ѯģIMEIʧ!\r\n");									
				}				
				break;
			case 2:		
				exUART_SendCharStr("  ڲѯICCID...\r\n");												
				sendReturn = IOT_sendAT(ATStrCCID, 5000);															// ѯICCID
				if(sendReturn == 1)
				{
					exUART_SendCharStr("  ICCID:");				
					exUART_SendCharStr(ATICCID);
					exUART_SendCharStr("\r\n");	
				}
				else
				{
					exUART_SendCharStr("  ѯICCIDʧ!\r\n");									
				}		
				break;
			case 3:
				exUART_SendCharStr("  ڲѯע...\r\n");										
				sendReturn = IOT_sendAT(ATStrCreg, 5000);															// ѯע״̬
				if(sendReturn == 1)
				{
					exUART_SendCharStr("  עɹ\r\n");				
				}
				else
				{
					exUART_SendCharStr("  עʧ!\r\n");									
				}
				break;
			case 4:
				exUART_SendCharStr("  ڲѯģźǿ...\r\n");										
				sendReturn = IOT_sendAT(ATStrCSQ, 5000);															// źǿ			
				if(sendReturn == 1)
				{
					exUART_SendCharStr("  ģźǿ:");				
					exUART_SendCharStr(ATCSQ);
					exUART_SendCharStr("\r\n");	
				}
				else
				{
					exUART_SendCharStr("  ѯģźǿʧ!\r\n");									
				}
				break;
			case 5:
				exUART_SendCharStr("  ģAPN\r\n");									
				sendReturn = IOT_sendAT(ATStrCGDCONT, 5000);													// APN
				if(sendReturn == 1)
				{
					exUART_SendCharStr("  ģAPNɹ\r\n");	
				}
				else if(sendReturn == 2)				
				{
					exUART_SendCharStr("  ģAPNʧܣȥPDP\r\n");			
					IOT_sendAT(ATStrCGACT0, 5000);																			// ȥPDP				
				}							
				else
				{
					exUART_SendCharStr("  ģAPNʱ\r\n");			
				}
				break;			
			case 6:				
				exUART_SendCharStr("  ڼPDPͨ\r\n");				
				sendReturn = IOT_sendAT(ATStrCGACT, 5000);														// PDP				
				if(sendReturn == 1)
				{
					exUART_SendCharStr("  PDPͨɹ\r\n");	
				}
				else
				{
					exUART_SendCharStr("  PDPͨʧ!\r\n");									
				}
				break;
			case 7:				
				exUART_SendCharStr("  ͸ģʽ...\r\n");				
				sendReturn = IOT_sendAT(ATStrMIPMODE, 5000);													// Ϊ͸ģʽ		
				if(sendReturn == 1)
				{
					exUART_SendCharStr("  ͸ģʽɹ\r\n");	
				}
				else
				{
					exUART_SendCharStr("  ͸ģʽʧ!\r\n");									
				}	
				break;
			case 8:
				exUART_SendCharStr("  TCP...\r\n");				
				sendReturn = IOT_sendAT(ATStrMIPOPEN, 5000);													// ͸ģʽ
				if(sendReturn == 1)
				{
					exUART_SendCharStr("  TCPƽ̨ɹ\r\n");	
				}
				else if(sendReturn == 2)
				{
					exUART_SendCharStr("  TCPƽ̨ʧ\r\n");	
				}
				else if(sendReturn == 3)
				{
					sendReturn = IOT_rcvAT(ATStrMIPOPEN, 10000);												// ȴسɹ 
					if(sendReturn == 1)
					{
						exUART_SendCharStr("  TCPƽ̨ɹ\r\n");	
					}
					else
					{
						exUART_SendCharStr("  TCPƽ̨ʧ\r\n");	
					}
				}
				if(sendReturn != 1)																										// ʧ
				{
					exUART_SendCharStr("  ڹر...\r\n");	
					if(IOT_sendAT(ATStrMIPCLOSE, 5000) == 1)														// Ͽ
					{
						exUART_SendCharStr("  رӳɹ\r\n");	
					}
					else
					{
						exUART_SendCharStr("  رʧ\r\n");	
					}
				}						
				break;
			default:
				break;
		}		
		if(sendReturn == 1)																												// ɹʶһ
		{
			initStep++;																															// в+1			
			HAL_Delay(500);			
		}
		else
		{
			if(sendReturn == 0)
			{
				initStep = 0;
			}
			HAL_Delay(1000);
			errorTime++;
			if(errorTime == 50)																										// 100ע᲻ɹػģϵͳ
			{
				exUART_SendCharStr("Ӵﵽ50, ϵͳλ...\r\n");				
				errorTime = 0;
				exUART_SendCharStr("4Gģڹػ...\r\n");
				IOT_PWR(0);																														// ģػ
				for(i=0; i<6; i++)																										// ȴ2Ӻٿ
				{
					HAL_Delay(10000);
					HAL_IWDG_Refresh(&hiwdg);																						// Źι
				}
				exUART_SendCharStr("Ƭڸλ...\r\n");				
				HAL_NVIC_SystemReset();																								// ϵͳ		
			}			
		}
		
		if(initStep == 9)																												// ӷɹ
		{
			tcpConnectStatus = 1;																										// TCPӳɹ		
			exUART_SendCharStr("-------------------------ϲ, TCPѾӳɹ-------------------------\r\n");							
			HAL_GPIO_WritePin(SYS_LED_GPIO_Port, SYS_LED_Pin, GPIO_PIN_SET);				// LED	
			exUART_SendCharStr("LED\r\n");
			break;
		}
	}	
}

// ܣػIOTģ顣mode 10ػ
// ɹأ1ʧܷأ0
uint8_t IOT_PWR(uint8_t mode)																									
{
	uint8_t i=0;
	uint8_t sendReturn = 0;																											// ֵ
	
	HAL_GPIO_WritePin(IOT_POWER_GPIO_Port, IOT_POWER_Pin, GPIO_PIN_SET);						
	if(mode == 1)
	{		
		HAL_Delay(1500);																													// 1.5sģ鿪
	}
	else if(mode == 0)
	{		
		HAL_Delay(3000);																													// ػ3sģػ
	}																																		
	HAL_IWDG_Refresh(&hiwdg);																										// ι
	HAL_GPIO_WritePin(IOT_POWER_GPIO_Port, IOT_POWER_Pin, GPIO_PIN_RESET);			// 
	if(mode == 1)
	{		
		HAL_Delay(10000);																													// ȴ5s
	}
	else if(mode == 0)
	{		
		HAL_Delay(15000);																													// ػȴ15s
	}
	HAL_IWDG_Refresh(&hiwdg);																										// ι
	
	if(mode == 1)																																// ҪȴATͨ
	{
		for(i=0; i<10; i++)																												// 35sATͨ
		{
			HAL_IWDG_Refresh(&hiwdg);																								// ι
			sendReturn = IOT_intoATMethod();																				// ATOK˵ͨ
			if(sendReturn == 1)																											// ʶɹ
			{
				break;
			}
		}		
	}
	else
	{
		sendReturn = 1;																														// ػҪжϷֵ
	}
	
	if(mode == 1)
	{
		if(sysLog)
		{
			exUART_SendCharStr("ģѾ\r\n");																			// ӡʾ
		}		
	}
	else
	{
		exUART_SendCharStr("ģѾػ\r\n");
	}
	
	return sendReturn;
}


uint8_t IOT_intoATMethod(void)																								// ATģʽ
{
	uint8_t sendReturn = 0;																											// ֵ
	uint8_t i = 0;																															// ѭֵ
	
	for(i=0; i<3; i++)																													// 3
	{
		HAL_IWDG_Refresh(&hiwdg);																									// Źι
		if(i == 2)
		{
			sendReturn = IOT_sendAT(ATStrATplus, 1000);																					// ++++++OK˵ATͨģʽ
		}
		else
		{
			sendReturn = IOT_sendAT(ATStrAT, 1000);																		// ++++++OK˵ATͨģʽ
		}		
		if(sendReturn ==1)																												// Աȳɹ
		{			
			break;
		}
		HAL_Delay(500);
	}	
	
	return sendReturn;
}
