#include "uart.h"
#include <string.h>
#include "time.h"
#include "sys.h"
#include "iot.h"

extern UART_HandleTypeDef huart1;
extern UART_HandleTypeDef huart2;
extern TIM_HandleTypeDef htim1;
extern TIM_HandleTypeDef htim2;

#define exhuart huart2
#define iothuart huart1
#define exUSART USART2
#define iotUSART USART1
#define exhtim htim2
#define iothtim htim1

uint8_t exUART_RxMaxNum = 255;																																				// ⲿڽ󳤶
uint8_t exUART_Buf[255];																																							// ⲿڽ飬exUART_RxMaxNumֽ
uint8_t exUART_Mark = 0;																																							// ⲿڽյݱ־
uint8_t exUART_RxCplt = 0;																																						// ⲿڽɱ־λ
uint8_t exUART_RxNum = 0;																																							// ⲿڽյĸ
uint8_t exUART_Once = 0;																																							// 0һνյݣ1ǵһ			
uint8_t exUART_OnceRxNum = 0;																																					// ϴνյĸ

uint8_t iotUART_RxMaxNum = 100;																																				// IOTڽ󳤶
uint8_t iotUART_Buf[100];																																							// IOTڽ飬iotUART_RxMaxNumֽ
uint8_t iotUART_Mark = 0;																																							// IOTڽյݱ־
uint8_t iotUART_RxCplt = 0;																																						// IOTڽɱ־λ
uint8_t iotUART_RxNum = 0;																																						// IOTڽյĸ
uint8_t iotUART_Once = 0;																																							// 0һνյݣ1ǵһ			
uint8_t iotUART_OnceRxNum = 0;																																				// ϴνյĸ

void exUART_Send(uint8_t *str)																																				// ⲿڷͺ
{
	while(HAL_UART_Transmit_IT(&exhuart, str, strlen((char*)str)) != HAL_OK);														// жϷ
}

void exUART_SendCharStr(char *str)																																		// ⲿڷͺ
{
	while(HAL_UART_Transmit_IT(&exhuart, (uint8_t*)str, strlen(str)) != HAL_OK);												// жϷ
}

void exUART_SendStr(const char *str)																																		// ⲿڷͺ
{
	while(HAL_UART_Transmit_IT(&exhuart, (uint8_t*)str, strlen(str)) != HAL_OK);												// жϷ
}

void iotUART_Send(uint8_t *str)																																				// IOTڷͺ
{
	while(HAL_UART_Transmit_IT(&iothuart, str, strlen((char*)str)) != HAL_OK);													// жϷ
}

void iotUART_SendConst(const char *str)																																// IOTڷͺ
{
	while(HAL_UART_Transmit_IT(&iothuart, (uint8_t*)str, strlen((char*)str)) != HAL_OK);								// (2)жϷ
}

void iotUART_SendCharStr(char *str)																																		// IOTڷͺ
{
	while(HAL_UART_Transmit_IT(&iothuart, (uint8_t*)str, strlen(str)) != HAL_OK);												// жϷ
}

void exUART_SendData(uint16_t data)																																		// ⲿڷ͵ֵ
{
	uint8_t str[4] = "0000";
	
	str[3] = data % 10 + '0';																																						// ֵתΪַ
	str[2] = data % 100 / 10 + '0';																																						// ֵתΪַ
	str[1] = data % 1000 / 100 + '0';																																			// ֵתΪַ
	str[0] = data / 1000 + '0';																																					// ֵתΪַ
	HAL_Delay(10);
	while(HAL_UART_Transmit_IT(&exhuart, (uint8_t*)str, 4) != HAL_OK);																	// жϷ
	HAL_Delay(10);
}

void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)																								// ڽɵĻص
{
	if(huart->Instance == exUSART)																																			// ȷⲿ
	{
		if(exUART_Once == 1)																																							// ǵһνյ
		{
			exUART_Buf[0] = exUART_Buf[exUART_OnceRxNum];																										// յĵһݷַ[0]λ
			exUART_Once = 0;
		}	
		if(exUART_RxNum < (exUART_RxMaxNum-1))																														// յֵûгⲿֵ򴢴浽
		{
			exUART_RxNum++;																																									// ⲿڽյĸ		
		}		
		while(HAL_UART_Receive_IT(&exhuart, (uint8_t*)&exUART_Buf[exUART_RxNum], 1) != HAL_OK);						// ⲿڣһνж					
		exTimer_Num = 0;																																									// ⲿTimerֵ֤ݵʱʱᳬʱ
		exUART_Mark = 1;																																									// ⲿڽյݱ־
	}
	else if(huart->Instance == iotUSART)																																// ȷIOT
	{
		if(iotUART_Once == 1)																																							// ǵһνյ
		{
			iotUART_Buf[0] = iotUART_Buf[iotUART_OnceRxNum];																								// յĵһݷַ[0]λ
			iotUART_Once = 0;
		}	
		if(iotUART_RxNum < (iotUART_RxMaxNum-1))																													// յֵûгIOTֵ򴢴浽
		{
			iotUART_RxNum++;																																								// IOTڽյĸ		
		}		
		while(HAL_UART_Receive_IT(&iothuart, (uint8_t*)&iotUART_Buf[iotUART_RxNum], 1) != HAL_OK);				// IOTڣһνж					
		iotTimer_Num = 0;																																									// IOT Timerֵ֤ݵʱʱᳬʱ
		iotUART_Mark = 1;																																									// IOTڽյݱ־
	}
}

void exUART_RxMetohd(void)
{
	if(exUART_Mark == 1)																																								// ⲿڽյ
	{			
		if(HAL_TIM_Base_GetState(&exhtim) != HAL_TIM_STATE_BUSY)																					// ⲿڶʱûд
		{
			HAL_TIM_Base_Start_IT(&exhtim);																																	// ʱ
		}			
	}
	if(exUART_RxCplt == 1)																																							// ⲿڽ																						
	{					
		if(exUART_Once == 1)																																							// ǵһνյ
		{
			exUART_Buf[0] = exUART_Buf[exUART_RxNum];
		}
		exUART_RxMetohdHandle();	
		HAL_TIM_Base_Stop_IT(&exhtim);																																		// رնʱ
		exTimer_Num = 0;																																									// ⲿTimerֵ
		exUART_OnceRxNum = exUART_RxNum;																																	// סεĽո´νմ
		exUART_RxNum = 0;																																									// ⲿڽյĸ			
		exUART_Mark = 0;   																																								// ⲿڽձ־
		exUART_RxCplt = 0;																																								// ⲿڽ־	
		exUART_Once = 1;																																									// 趨Ϊǵһνյ
	}
}

void iotUART_RxMetohd(void)
{
	if(iotUART_Mark == 1)																																								// IOTڽյ
	{			
		if(HAL_TIM_Base_GetState(&iothtim) != HAL_TIM_STATE_BUSY)																					// iotʱûд
		{
			HAL_TIM_Base_Start_IT(&iothtim);																																// iotʱ
		}			
	}
	if(iotUART_RxCplt == 1)																																							// iotڽ																						
	{							
		if(iotUART_Once == 1)																																							// ǵһνյ
		{
			iotUART_Buf[0] = iotUART_Buf[iotUART_RxNum];
		}
		iotUART_RxMetohdHandle();		
		HAL_TIM_Base_Stop_IT(&iothtim);																																		// رiotʱ
		iotTimer_Num = 0;																																									// iot Timerֵ
		iotUART_OnceRxNum = iotUART_RxNum;																																// סεĽո´νմ
		iotUART_RxNum = 0;																																								// iotڽյĸ			
		iotUART_Mark = 0;   																																							// iotڽձ־
		iotUART_RxCplt = 0;																																								// iotڽ־	
		iotUART_Once = 1;																																									// 趨Ϊǵһνյ
	}
}

uint8_t getIotUartLocation(uint8_t dataValue, uint8_t num)																						// ȡIOTdataValueڵnumλ
{
	uint8_t i,j=0;
	
	for(i=0; i<iotUART_RxNum; i++)
	{
		if(iotUART_Buf[i] == dataValue)	{ j++; }
		if(j == num) { return i; }
	}
	
	return 0;
}

void exUART_RxMetohdHandle(void)																																			// ⲿڽܴ
{		
	if(sysLog)
	{
		exUART_SendCharStr("ǣ");
		while(HAL_UART_Transmit_IT(&exhuart, (uint8_t *)exUART_Buf, exUART_RxNum) != HAL_OK);							// ⲿϣӡյ	
		exUART_SendCharStr("\r\n");	
	}	
	
	if((exUART_Buf[0]=='A') && (exUART_Buf[1]=='T') && (exUART_Buf[2]=='+') && (exUART_Buf[3]=='I')								// AT+IMEIѯģIMEI
		 && (exUART_Buf[4]=='M') && (exUART_Buf[5]=='E') && (exUART_Buf[6]=='I') && (exUART_RxNum == 7))
	{
		ATIMEIMark = 1;
	}
	else if((exUART_Buf[0]=='A') && (exUART_Buf[1]=='T') && (exUART_Buf[2]=='+') && (exUART_Buf[3]=='I')								// AT+ICCIDѯSIM ICCID
		 && (exUART_Buf[4]=='C') && (exUART_Buf[5]=='C') && (exUART_Buf[6]=='I') && (exUART_Buf[7]=='D') && (exUART_RxNum == 8))
	{
		ATICCIDMark = 1;		
	}
	else if((exUART_Buf[0]=='A') && (exUART_Buf[1]=='T') && (exUART_Buf[2]=='+') && (exUART_Buf[3]=='C')								// AT+CSQѯģCSQźǿ
		 && (exUART_Buf[4]=='S') && (exUART_Buf[5]=='Q') && (exUART_RxNum == 6))
	{
		ATCSQMark = 1;
	}
	else																																																								// AT
	{
		if(tcpConnectStatus == 1)																																													// ѾϷ
		{
			if(sysLog)
			{
				exUART_SendCharStr("LOG->͸ݸ:");
				while(HAL_UART_Transmit_IT(&exhuart, (uint8_t*)exUART_Buf, exUART_RxNum) != HAL_OK);		// ͸
				exUART_SendCharStr("<-LOG\r\n");
			}			
			while(HAL_UART_Transmit_IT(&iothuart, (uint8_t*)exUART_Buf, exUART_RxNum) != HAL_OK);		// ͸
		}
		else
		{
			exUART_SendCharStr("δӷ,,밴չ涨ʽ!\r\n");
		}
	}
}

void iotUART_RxMetohdHandle(void)																																											// IOTڽմ
{			
	if(sysLog)
	{
		exUART_SendCharStr("ܵTCP:");
		while(HAL_UART_Transmit_IT(&exhuart, (uint8_t *)iotUART_Buf, iotUART_RxNum) != HAL_OK);														// ⲿϣӡյ				
		exUART_SendCharStr("\r\n");
	}
	
	// ҪжTCPߣ
//	if((iotUART_Buf[2]=='+') && (iotUART_Buf[3]=='Z') && (iotUART_Buf[4]=='I') && (iotUART_Buf[5]=='P')									// +ZIPSTAT: 1,0 --> 
//		 && (iotUART_Buf[6]=='S') && (iotUART_Buf[7]=='T') && (iotUART_Buf[8]=='A') && (iotUART_Buf[9]=='T')
//		 && (iotUART_Buf[14]=='0'))
//	{
//		exUART_SendCharStr("LOG:TCP ERROR\r\n");	
//		tcpConnectStatus = 0;
//	}	
}

uint8_t IOT_sendAT(const char* AT, uint16_t timeOut)																								// ܣģ鷢ATָ
{
	uint32_t Start_Time;																																							// ʱ	
	uint8_t sendReturn = 0;																																						// ֵ

	if(strcmp(ATStrDoiot, AT) != 0)																																		// Ҫ
	{
		iotUART_SendConst(AT);																																					// ATָ					
		exUART_SendCharStr("͸ML302AT:");		
		exUART_SendStr(AT);
	}	
	Start_Time = HAL_GetTick();																																				// ȡʱ
	while(1)
	{
		HAL_IWDG_Refresh(&hiwdg);																																				// Źι
		sendReturn = iotUART_Handle_Const(AT);																														// 2
		if(sendReturn != 0)																																							// յݣҶԱ
		{
			return sendReturn;
		}
		if((HAL_GetTick() - Start_Time) > timeOut)																											// ʱ
		{
			return 0;																																											// ˳ѭʶʧܵı־
		}
	}
}

uint8_t IOT_rcvAT(const char* AT, uint16_t timeOut)																									// ܣȴIOT
{
	uint32_t Start_Time;																																							// ʱ	
	uint8_t sendReturn = 0;																																						// ֵ

	Start_Time = HAL_GetTick();																																				// ȡʱ
	while(1)
	{
		HAL_IWDG_Refresh(&hiwdg);																																				// Źι
		sendReturn = iotUART_Handle_Const(AT);																														// 2
		if(sendReturn != 0)																																							// յݣҶԱ
		{
			return sendReturn;
		}
		if((HAL_GetTick() - Start_Time) > timeOut)																											// ʱ
		{
			return 0;																																											// ˳ѭʶʧܵı־
		}
	}
}


uint8_t iotUART_Handle_Const(const char* AT)																												// ATIOTڽմ
{
	uint8_t sendReturn = 0, i;																																				// ֵ
	
	if(iotUART_Mark == 1)																																							// iotڽյ
	{			
		if(HAL_TIM_Base_GetState(&iothtim) != HAL_TIM_STATE_BUSY)																				// iotʱûд
		{
			HAL_TIM_Base_Start_IT(&iothtim);																															// ʱ
		}			
	}
	if(iotUART_RxCplt == 1)																																						// iotڽ																						
	{					
		if(iotUART_Once == 1)																																						// ǵһνյ
		{
			iotUART_Buf[0] = iotUART_Buf[iotUART_RxNum];
		}
		
		if(sysLog)
		{
			exUART_SendCharStr("LOG->յģ:");
			while(HAL_UART_Transmit_IT(&exhuart, (uint8_t*)iotUART_Buf, iotUART_RxNum) != HAL_OK);				// յͨexڷͳȥ			
			exUART_SendCharStr("<-LOG\r\n");
		}		

		exUART_RxMetohd();																																							// ⲿݴ
		
		
		if(strcmp(AT, ATStrAT) == 0)																																		// AT+++
		{
			if(doncmp(iotUART_Buf, ATStrATOK, iotUART_RxNum) == 0)																				// ȶԳɹ+++OK
			{
				sendReturn = 1;																																							// سɹ
			}
			else
			{
				sendReturn = 2;																																							// ʧ
			}
		}
		else if(strcmp(AT, ATStrATplus) == 0)																														// AT+++
		{
			if(doncmp(iotUART_Buf, ATStrATplus, 3) == 0)																									// ȶԳɹ+++OK
			{
				sendReturn = 1;																																							// سɹ
			}
			else
			{
				sendReturn = 2;																																							// ʧ
			}
		}
		else if(strcmp(AT, ATStrIMEI) == 0)																															// ATAT+IMEI
		{
			for(i=0; i<15; i++)
			{
				if(((iotUART_Buf[getIotUartLocation(':', 1)+2+i] > '0') && (iotUART_Buf[getIotUartLocation(':', 1)+2+i] < '9')) || (iotUART_Buf[getIotUartLocation(':', 1)+2+i] == '0') || (iotUART_Buf[getIotUartLocation(':', 1)+2+i] == '9'))		// ȷ
				{
					ATIMEI[i] = iotUART_Buf[getIotUartLocation(':', 1)+2+i];																	// IMEI 15λ
				}
				else
				{
					sendReturn = 2;																																						// ʧ
					break;																																										// ѭ
				}
			}			
			ATIMEI[15] = '\0';																																						// 
			if(ATIMEI[0] == '8')																																					// IMEIһλ'8'
			{
				sendReturn = 1;																																							// ɹ
			}
			else
			{
				sendReturn = 2;																																							// ʧ
			}
		}
		else if(strcmp(AT, ATStrCCID) == 0)																															// ATAT+CCID
		{
			for(i=0; i<20; i++)
			{
				ATICCID[i] = iotUART_Buf[getIotUartLocation(':', 1)+2+i];																		// ȡ1:
			}					
			ATICCID[20] = '\0';			
			if(ATICCID[0] == '8')																																					// ICCIDһλ'8'
			{
				sendReturn = 1;																																							// ɹ
			}
			else
			{
				sendReturn = 2;																																							// ʧ
			}
		}
		else if(strcmp(AT, ATStrCreg) == 0)																															// ATAT+CREG
		{
			if((iotUART_Buf[getIotUartLocation(',', 1)+1]=='1') || (iotUART_Buf[getIotUartLocation(',', 1)+1]=='4') || (iotUART_Buf[getIotUartLocation(',', 1)+1]=='5'))		// ȡ1,+1λ
			{
				sendReturn = 1;																																							// 1
			}				
			else
			{
				sendReturn = 2;																																							// ʧ
			}
		}
		else if(strcmp(AT, ATStrCSQ) == 0)																															// AT+CSQ
		{		
			if((getIotUartLocation(',', 1) - (getIotUartLocation(':', 1))) == 4)
			{
				for(i=0; i<2; i++)
				{
					ATCSQ[i] = iotUART_Buf[getIotUartLocation(':', 1)+2+i];																		// ȡ1:+1λ
				}	
				ATCSQ[2] = '\0';
				if(((ATCSQ[0] > '0') && (ATCSQ[0] < '4')) && (((ATCSQ[1] > '0') && (ATCSQ[1] < '9')) || ((ATCSQ[1] == '0') || (ATCSQ[0] == '9'))))
				{
					sendReturn = 1;																																						// سɹ		
				}
				else
				{
					sendReturn = 2;																																						// ʧ
				}
			}
			else
			{
				ATCSQ[0] = iotUART_Buf[getIotUartLocation(':', 1)+2];																				// ȡ1:+1λ
				ATCSQ[1] = '\0';
				if(((ATCSQ[1] > '0') && (ATCSQ[1] < '9')) || (ATCSQ[1] == '0') || (ATCSQ[0] == '9'))
				{
					sendReturn = 1;																																						// سɹ		
				}
				else
				{
					sendReturn = 2;																																						// ʧ
				}
			}
		}
		else if(strcmp(AT, ATStrCGDCONT) == 0)																													// ATAT+CGDCONT, APN
		{			
			if(doncmp(iotUART_Buf, ATStrCGDCONTOK, strlen(ATStrCGDCONTOK)))
			{
				sendReturn = 1;																																							// سɹ	
			}
			else
			{
				sendReturn = 2;																																							// ʧ
			}
		}
		else if(strcmp(AT, ATStrCGACT) == 0)																														// ATAT+CGACT=1,1
		{
			if((iotUART_Buf[getIotUartLocation(',', 1)+6]=='O') && (iotUART_Buf[getIotUartLocation(',', 1)+7]=='K'))																						// OK
			{				
				sendReturn = 1;																																							// 1								
			}
			else
			{
				sendReturn = 2;																																							// ʧ
			}
		}
		else if(strcmp(AT, ATStrMIPMODE) == 0)																													// ATAT+MIPMODE=0,1
		{
			if((iotUART_Buf[getIotUartLocation(',', 1)+6] == 'O')	&& (iotUART_Buf[getIotUartLocation(',', 1)+7] == 'K'))			
			{				
				sendReturn = 1;																																							// سɹ								
			}
			else
			{
				sendReturn = 2;																																							// ʧ
			}
		}		
		else if(strcmp(AT, ATStrMIPOPEN) == 0)																													// ATATStrMIPOPENӷ
		{	
			if(doncmp(iotUART_Buf, ATStrConnectOK, strlen(ATStrConnectOK)))																// ӳɹ															
			{				
				sendReturn = 1;																																							// سɹ								
			}
			else if(doncmp(iotUART_Buf, ATStrMIPOPENOK, strlen(ATStrMIPOPENOK)))													// ֱӳɹ															
			{				
				sendReturn = 1;																																							// سɹ								
			}
			else if(doncmp(iotUART_Buf, ATStrMIPOPENERROR, strlen(ATStrMIPOPENERROR)))													// ʧܷʧ
			{				
				sendReturn = 2;																																							// سɹ								
			}
			else
			{
				sendReturn = 3;																																							// ʧ
			}																																																				
		}
		else if(strcmp(AT, ATStrMIPCLOSE) == 0)																													// ATAT+MIPCLOSEϿ
		{
			if(doncmp(iotUART_Buf, ATStrMIPCLOSEOK, strlen(ATStrMIPCLOSEOK)))															// رճɹ
			{				
				sendReturn = 1;																																							// سɹ								
			}
		}	
		
		HAL_TIM_Base_Stop_IT(&iothtim);																																		// رնʱ2
		iotTimer_Num = 0;																																									// Timer2ֵ
		iotUART_OnceRxNum = iotUART_RxNum;																																	// סεĽո´νմ
		iotUART_RxNum = 0;																																								// 㴮2յĸ			
		iotUART_Mark = 0;   																																							// 㴮2ձ־
		iotUART_RxCplt = 0;																																								// 㴮2־	
		iotUART_Once = 1;																																									// 趨Ϊǵһνյ
	}
	
	return sendReturn;
}
